package javax.print;

import javax.print.attribute.AttributeSet;
import javax.print.attribute.Attribute;
import javax.print.attribute.PrintServiceAttribute;
import javax.print.attribute.PrintServiceAttributeSet;
import javax.print.event.PrintServiceAttributeListener;

public interface PrintService
{
    public abstract String getName();
    
    public abstract DocPrintJob createPrintJob();
    
    public abstract void addPrintServiceAttributeListener(PrintServiceAttributeListener p0);
    
    public abstract void removePrintServiceAttributeListener(PrintServiceAttributeListener p0);
    
    public abstract PrintServiceAttributeSet getAttributes();
    
    public abstract <T extends PrintServiceAttribute> T getAttribute(Class<T> p0);
    
    public abstract DocFlavor[] getSupportedDocFlavors();
    
    public abstract boolean isDocFlavorSupported(DocFlavor p0);
    
    public abstract Class<?>[] getSupportedAttributeCategories();
    
    public abstract boolean isAttributeCategorySupported(Class<? extends Attribute> p0);
    
    public abstract Object getDefaultAttributeValue(Class<? extends Attribute> p0);
    
    public abstract Object getSupportedAttributeValues(Class<? extends Attribute> p0, DocFlavor p1, AttributeSet p2);
    
    public abstract boolean isAttributeValueSupported(Attribute p0, DocFlavor p1, AttributeSet p2);
    
    public abstract AttributeSet getUnsupportedAttributes(DocFlavor p0, AttributeSet p1);
    
    public abstract ServiceUIFactory getServiceUIFactory();
    
    public abstract boolean equals(Object p0);
    
    public abstract int hashCode();
}
